#include <at91sam7x256.h>
#include <lib_at91sam7x256.h>
#include "PWM.h"
#include "tdelay.h"

/// PWM frequency in Hz.
#define PWM_FREQUENCY               500000
#define BOARD_MCK					48000000

/// Maximum duty cycle value.
#define MAX_DUTY_CYCLE              0x0FFE
#define MIN_DUTY_CYCLE          	2


int main(void){
	int i;
	// DELAY Init.
	init_delay();
	
	// PWM UNIT POWER ON
	AT91C_BASE_PMC->PMC_PCER |= 1 << AT91C_ID_PWMC;
	
	PWMC_Configure_PIO(PORT_PWMC_PWM0,PIN_PWMC_PWM0);
	// Set clock A to run at 500kHz  (clock B is not used)
    PWMC_ConfigureClocks(PWM_FREQUENCY , 0, BOARD_MCK);
	// Configure PWMC channel #0(left-aligned)
    PWMC_ConfigureChannel(0, AT91C_PWMC_CPRE_MCKA, 0, 0);
    PWMC_SetPeriod(0, MAX_DUTY_CYCLE);
    PWMC_SetDutyCycle(0, MIN_DUTY_CYCLE);
	// Enable channel #0
    PWMC_EnableChannel(0);
	
	PWMC_Configure_PIO(PORT_PWMC_PWM1,PIN_PWMC_PWM1);
	// Configure PWMC channel #0(left-aligned)
    PWMC_ConfigureChannel(1, AT91C_PWMC_CPRE_MCKA, 0, 0);
    PWMC_SetPeriod(1, MAX_DUTY_CYCLE);
    PWMC_SetDutyCycle(1, MIN_DUTY_CYCLE);
	// Enable channel #1
    PWMC_EnableChannel(1);
	  

 while(1){
	for(i=20;i<0x0FFF;i+=40){
			PWMC_SetPeriod(0, i);
			PWMC_SetPeriod(1, 0x0FFF-i+20);
			delay_ms(10); 
	}

		for(i=0x0FFF;i>20;i-=40){
			PWMC_SetPeriod(0, i);
			PWMC_SetPeriod(1, 0x0FFF-i+20);
			delay_ms(10); 
	}
	
 }

 return 0;
}
